package com.jeeplus.modules.sg.overheadline.service;

import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.modules.sg.overheadline.entity.Settlement;
import com.jeeplus.modules.sg.overheadline.mapper.SettlementMapper;
import com.jeeplus.modules.sg.overheadline.util.BashInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import java.util.*;

@Service
public class SettlementService {
    @Autowired
    private SettlementMapper settlementMapper;

    /*
        添加结算工程表
     */
    @Transactional
    public void save(MultipartFile file,String id){
        try {
            List<Settlement> settlementList = getSettlement(file,id);
            for (int i = 0; i < settlementList.size(); i++) {
                settlementMapper.sava(settlementList.get(i));
            }
        }catch (Exception c){
            c.printStackTrace();
        }
    }
    /*
        查找结算工程表
     */
    public List<Settlement> selectSettlementService(String id){
        return settlementMapper.selectSettlement(id);
    }

    /*
     获取结算数据
    */
    public List<Settlement> getSettlement(MultipartFile file, String id) throws  Exception{
        ImportExcel completion = new ImportExcel(file,1, BashInfo.SHEET_HZB);
        ImportExcel built = new ImportExcel(file,1,BashInfo.SHEET_GCHZ);
        ImportExcel division = new ImportExcel(file,1,BashInfo.SHEET_FBFXJJ);
        ImportExcel wordFirst = new ImportExcel(file,1,BashInfo.SHEET_CSB);
        ImportExcel otherProject = new ImportExcel(file,1,BashInfo.SHEET_QTFY);
        ImportExcel feesProject  = new ImportExcel(file,1,BashInfo.SHEET_GFQD);
        Map<String,Object[]> builtMap = getCompletionWorks(completion);
        Double builtTotal = getBuiltStilts(built);
        Double[] divisiontotal = getDivisionOf(division);
        Double wordtotal = getWording(wordFirst);
        Double otherTotal = getOtherProject(otherProject);
        Double feescount  = getFeesTotal(feesProject);
        return getTotality(builtMap,builtTotal,divisiontotal,wordtotal,otherTotal,feescount,id);
    }
    /*
      获取工程竣工数据
     */
    public Map<String,Object[]> getCompletionWorks(ImportExcel importExcel){
        Map<String,Object[]> map  = new LinkedHashMap<String, Object[]>();
        Integer lastDataRowNum =  importExcel.getLastDataRowNum();
        String key="";
        Double val=0.0;
        String text = "";
        Object[] objects;
        for (int i = 2; i < lastDataRowNum; i++) {
            objects = new Object[2];
            key =  importExcel.getValue(i+1,1);
            val = importExcel.getDouble(i+1,2);
            text=importExcel.getValue(i+1,3);
            switch (key){
                case BashInfo.JS_FBFX:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_CBRF:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_CSXM:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_QTXM:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_GF:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_SJ:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_FBRF:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_JGJS:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_BZZS:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_KJJG:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
                case BashInfo.JS_GCJS:
                    val = importExcel.getDouble(i+1,2);
                    text=importExcel.getValue(i+1,3);
                    objects[0] = val;
                    objects[1] = text;
                    map.put(key, objects);
                    break;
            }
        }
        return  map;
    }
    /*
      获取架空合计
     */
    public Double getBuiltStilts(ImportExcel importExcel){
        Double value = 0.0;
        String type="";
        Integer lastDataRowNum = importExcel.getLastDataRowNum();
        for (int i = 2; i < lastDataRowNum ; i++) {
            type = importExcel.getValue(i+1,0);
            if (type.equals(BashInfo.QT_HJ)){
                value = importExcel.getDouble(i+1,2);
                break;
            }
        }
        return value;
    }
    /*
      获取措施费合计
     */
    public Double getWording(ImportExcel importExcel){
        Double value = 0.0;
        String type = "";
        Integer lastDataRowNum = importExcel.getLastDataRowNum();
        for (int i = 2; i <lastDataRowNum ; i++) {
            type = importExcel.getValue(i+1,0);
            if (type.equals(BashInfo.QT_HJ)){
                value = importExcel.getDouble(i+1,4);
                break;
            }
        }
        return value;
    }
    /*
      获取其他项目费
     */
    public Double getOtherProject(ImportExcel importExcel){
        Double value = 0.0;
        String type= "";
        Integer lastDataRowNum = importExcel.getLastDataRowNum();
        for (int i = 0; i <lastDataRowNum ; i++) {
            type = importExcel.getValue(i+1,0);
            if (type.equals(BashInfo.QT_HJ)){
                value = importExcel.getDouble(i+1,2);
                break;
            }
        }
        return  value;
    }
    /*
      获取规费合计
     */
    public Double getFeesTotal(ImportExcel importExcel){
        Double value = 0.0;
        String type = "";
        Integer lastDataRowNum = importExcel.getLastDataRowNum();
        for (int i = 2; i < lastDataRowNum; i++) {
            type = importExcel.getValue(i+1,0);
            if (type.equals(BashInfo.QT_HJ)){
                value = importExcel.getDouble(i+1,4);
                break;
            }
        }
        return value;
    }
    /*
      获取分工清单
     */
    public Double[] getDivisionOf(ImportExcel importExcel){
        Double count = 0.0;
        Double fpermoney =  0.0;
        Double cpermoney = 0.0;
        String type="";
        Integer lastDataRowNum = importExcel.getLastDataRowNum();
        for (int i = 0; i < lastDataRowNum; i++) {
            type = importExcel.getValue(i+1,2);
            if (type.equals(BashInfo.PROJECTNAME)) {
                count = importExcel.getDouble(i + 1, 12);
                cpermoney = importExcel.getDouble(i + 1, 14);
                fpermoney = importExcel.getDouble(i + 1, 15);
                break;
            }
        }
        Double[] val = new Double[3];
        val[0] = count;
        val[1] = cpermoney;
        val[2] = fpermoney;
        return  val;
    }
    /*
      结算汇总
     */
    public List<Settlement> getTotality(Map<String,Object[]> builtMap,Double builtTotal,Double[] divisiontotal,Double wordtotal,Double otherTotal,Double feescount,String id){
        List<Settlement> list = new ArrayList<Settlement>();
        String key="";
        Double count=0.0;
        Double countProtect=0.0;
        Double creatProtect=0.0;
        String status="1";
        Settlement  settlement;
        String reason = "数据核验正确";
        for (Map.Entry<String,Object[]> map:builtMap.entrySet()){
            key = map.getKey();
            Object[] val = map.getValue();
            double money = Double.parseDouble(val[0].toString());
            String remarks=val[1].toString();
            switch (key){
                case BashInfo.JS_FBFX:
                    if(money==builtTotal&&money==divisiontotal[0]){
                        status="0";
                        count+=money;
                    }else {
                        reason = BashInfo.RESON_FBFX;
                    }
                    break;
                case  BashInfo.JS_CBRF:
                    if(money==divisiontotal[1]){
                        status="0";
                        count+=money;
                    }else {
                        reason = BashInfo.RESON_CBRF;
                    }
                    break;
                case BashInfo.JS_CSXM:
                    if(money==wordtotal){
                        status="0";
                        count+=money;
                    }else {
                        reason = BashInfo.RESON_CSXM;
                    }
                    break;
                case BashInfo.JS_QTXM:
                    if(money==wordtotal){
                        status="0";
                        count+=money;
                    }else {
                        reason = BashInfo.RESON_QTXM;
                    }
                    break;
                case BashInfo.JS_GF:
                    if(money==feescount){
                        status="0";
                        count+=money;
                    }else {
                        reason = BashInfo.RESON_GF;
                    }
                    break;
                case BashInfo.JS_FBRF:
                    if(money==divisiontotal[2]){
                        status="0";
                        count+=money;
                    }else {
                        reason = BashInfo.RESON_FBRF;
                    }
                    break;
                case BashInfo.JS_SJ:
                    status="0";
                    count+=money;
                    break;
                case BashInfo.JS_JGJS:
                    if(money==count){
                        status="0";
                        countProtect+=money;
                    }else {
                        reason = BashInfo.RESON_JGJS;
                    }
                    break;
                case BashInfo.JS_BZZS:
                    status="0";
                    countProtect+=money;
                    break;
                case BashInfo.JS_KJJG:
                    status="0";
                    creatProtect=money;
                    break;
                case BashInfo.GCJS:
                    Double reduce = countProtect-creatProtect;
                    if (money==reduce){
                        status="0";
                    }else {
                        reason = BashInfo.RESON_GCJS;
                    }
                    break;
            }
            settlement = new Settlement();
            settlement.setId(id);
            settlement.setEntryName(key);
            settlement.setMoney(money);
            settlement.setStatus(status);
            settlement.setRemarks(remarks);
            settlement.setReason(reason);
            list.add(settlement);
            status="1";
            reason = "数据核验正确";
        }
        return list;
    }
}
