package com.jeeplus.modules.sg.overheadline.util;

import com.jeeplus.common.utils.excel.ImportExcel;

public class BashInfo {
    public static final String PROJECTNAME = "架空线路";
    public static final String SHEET_FBFXJJ = "分部分项工程量清单计价表";
    public static final String SHEET_HZB = "工程项目竣工结算汇总表";
    public static final String SHEET_CSB = "措施项目清单计价表（一）";
    public static final String SHEET_QTFY = "其他项目清单计价表";
    public static final String SHEET_GFQD = "规费项目清单计价表";
    public static final String SHEET_GCHZ = "架空线路工程费用汇总表";

    public static final String JCGC = "1 基础工程";
    public static final String GTGC = "2 杆塔工程";
    public static final String JDGC = "3 接地工程";
    public static final String JXGC = "4 架线工程";
    public static final String FJAZGC = "5 附件安装工程";
    public static final String FZGC = "6 辅助工程";

    public static final String RATIO_RGTC = "人工调差系数";
    public static final String RATIO_CLTC = "材料调差系数";
    public static final String RATIO_JXTC = "机械调差系数";
    public static final String RATIO_CCRGTC = "拆除人工调差系数";
    public static final String RATIO_CCCLTC = "拆除材料调差系数";
    public static final String RATIO_CCJXTC = "拆除机械调差系数";

    public static final String CS_LS = "临时设施费";
    public static final String CS_AQWM = "安全文明施工费";
    public static final String GF_WXZY = "危险作业意外伤害保险费";
    public static final String QT_SGCDZY = "施工场地租用费";
    public static final String QT_ZBDL = "招标代理费";
    public static final String QT_HJ = "合计";
    public static final String BZZSSL = "补增值税税率调整差额";
    public static final String KJJGCC = "扣减甲供材超供材料费";
    public static final String GCJS = "工程结算价";
    public static final String TBJG = "竣工结算价合计";
    public static final String TBJG1 = "投标报价";

    public static final String HZ_JCGC = "基础工程";
    public static final String HZ_GTGC = "杆塔工程";
    public static final String HZ_JDGC = "接地工程";
    public static final String HZ_JXGC = "架线工程";
    public static final String HZ_FJAZGC = "附件安装工程";
    public static final String HZ_FZ = "辅助工程";

    public static final String TZ_RGF = "人工费";
    public static final String TZ_CBRCG = "承包分采购";
    public static final String TZ_FBRCG = "发包人采购";
    public static final String TZ_JX = "机械费";
    public static final String TZ_CSF1 = "措施费-1";
    public static final String TZ_CSF2 = "措施费-2";
    public static final String TZ_CSF3 = "措施费二";
    public static final String TZ_QTF = "其他费";
    public static final String TZ_GF = "规费";
    public static final String TZ_SF = "税费";

    public static final String JS_FBFX="分部分项工程费";
    public static final String JS_CBRF="承包人采购设备费";
    public static final String JS_CSXM="措施项目费";
    public static final String JS_QTXM="其他项目费";
    public static final String JS_GF="规费";
    public static final String JS_SJ="税金 (税率: 9%)";
    public static final String JS_FBRF="发包人采购材料费";
    public static final String JS_JGJS="竣工结算价合计";
    public static final String JS_BZZS="补增值税税率调整差额";
    public static final String JS_KJJG="扣减甲供材超供材料费";
    public static final String JS_GCJS="工程结算价";

    public static final String RESON_FBFX="分部分项工程费";
    public static final String RESON_CBRF="承包人采购设备费";
    public static final String RESON_CSXM="措施项目费";
    public static final String RESON_QTXM="其他项目费";
    public static final String RESON_GF="规费";
    public static final String RESON_SJ="税金 (税率: 9%)";
    public static final String RESON_FBRF="发包人采购材料费";
    public static final String RESON_JGJS="竣工结算价合计";
    public static final String RESON_BZZS="补增值税税率调整差额";
    public static final String RESON_KJJG="扣减甲供材超供材料费";
    public static final String RESON_GCJS="工程结算价";



    //主体模块WBSID
    public static final String[] WBSIDS = {"39100000","39200000","39300000","39400000","39500000","39600000"};

    public static final String[] HZ_ALL = {HZ_JCGC,HZ_GTGC,HZ_JDGC,HZ_JXGC,HZ_FJAZGC,HZ_FZ};
    public static final String[] MX_ALL ={JCGC,GTGC,JDGC,JXGC,FJAZGC,FZGC};


    /**
     *获取措施费率
     */
    public static double[] getCsRate(ImportExcel importExcel){
        int lastRow = importExcel.getLastDataRowNum();
        double lsRate = 0.00;
        double aqRate = 0.00;
        double totalRate = 0.00;
        for(int i=2;i<lastRow;i++){
            String type = importExcel.getValue(i+1,1);
            if(type.equals(CS_LS)){
                lsRate = importExcel.getDouble(i+1,3);
            }
            if(type.equals(CS_AQWM)){
                aqRate = importExcel.getDouble(i+1,3);
            }
            totalRate += importExcel.getDouble(i+1,3);
        }
        double[] rate = new double[2];
        rate[0] = (lsRate+aqRate)/100;
        rate[1] = (totalRate-lsRate-aqRate)/100;
        return  rate;
    }

    /**
     *获取规费率
     */
    public static double[] getGfRate(ImportExcel importExcel) {
        int lastRow = importExcel.getLastDataRowNum();
        double totalRate = 0.00;
        double wxzyRate = 0.00;
        for (int i = 2; i < lastRow; i++) {
            String type = importExcel.getValue(i + 1, 1);
            if (type.equals(GF_WXZY)) {
                wxzyRate = importExcel.getDouble(i + 1, 3);
            }
            if (!importExcel.getValue(i + 1, 2).equals("")) {
                totalRate += importExcel.getDouble(i + 1, 3);
            }
        }
        double[] rate = new double[2];
        rate[0] = wxzyRate / 100;
        rate[1] = (totalRate - wxzyRate) / 100;
        return rate;
    }

    /**
     * 获取其他费用
     */
    public static double[] getQtFees(ImportExcel importExcel) {
        int lastRow = importExcel.getLastDataRowNum();
        double cdFree = 0.00;
        double zbFree = 0.00;
        double totalFree = 0.00;
        for(int i=2;i<lastRow;i++){
            String type = importExcel.getValue(i+1,1);
            String type1 = importExcel.getValue(i+1,0);
            if(type.equals(QT_SGCDZY)){
                cdFree = importExcel.getDouble(i+1,2);
            }
            if(type.equals(QT_ZBDL)){
                zbFree = importExcel.getDouble(i+1,2);
            }
            if(type1.equals(QT_HJ)){
                totalFree = importExcel.getDouble(i+1,2);
            }
        }
        double[] rate = new double[3];
        rate[0] = cdFree;
        rate[1] = zbFree;
        rate[2] = totalFree-cdFree-zbFree;
        return  rate;
    }

    /**
     * 获取工程结算价
     */
    public static double getGcjsFee(ImportExcel importExcel){
        int lastRow = importExcel.getLastDataRowNum();
        double gcjs = 0.00;
        for(int i=0;i<lastRow;i++){
            String type = importExcel.getValue(i+1,1);
            if(type.equals(BashInfo.TBJG) || type.equals(BashInfo.GCJS)){
                gcjs = importExcel.getDouble(i+1,2);
            }
        }
        return  gcjs;

    }

}
